org.apache.xml.dtm.ref.dom2dtm

## Class DOM2DTMdefaultNamespaceDeclarationNode

- java.lang.Object
- - org.apache.xml.dtm.ref.dom2dtm.DOM2DTMdefaultNamespaceDeclarationNode

All Implemented Interfaces:
  Attr, Node, TypeInfo

    public class DOM2DTMdefaultNamespaceDeclarationNode
    extends java.lang.Object
    implements Attr, TypeInfo

This is a kluge to let us shove a declaration for xml: into the DOM2DTM model. Basically, it creates a proxy node in DOM space to carry the additional information. This is _NOT_ a full DOM implementation, and shouldn't be one since it sits alongside the DOM rather than becoming part of the DOM model. (This used to be an internal class within DOM2DTM. Moved out because I need to perform an instanceof operation on it to support a temporary workaround in DTMManagerDefault.) %REVIEW% What if the DOM2DTM was built around a DocumentFragment and there isn't a single root element? I think this fails that case... %REVIEW% An alternative solution would be to create the node _only_ in DTM space, but given how DOM2DTM is currently written I think this is simplest.

### Field Summary

### Fields inherited from interface org.w3c.dom.Node

`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

### Fields inherited from interface org.w3c.dom.TypeInfo

`DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION`

### Method Summary

Methods
`Node` `appendChild(Node a)` Adds the node `newChild` to the end of the list of children of this node.
`Node` `cloneNode(boolean deep)` Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes.
`short` `compareDocumentPosition(Node other)` Compares a node with this node with regard to their position in the document.
`NamedNodeMap` `getAttributes()` A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
`java.lang.String` `getBaseURI()` The absolute base URI of this node or `null` if undefined.
`NodeList` `getChildNodes()` A `NodeList` that contains all children of this node.
`java.lang.Object` `getFeature(java.lang.String feature, java.lang.String version)` This method returns a specialized object which implements the specialized APIs of the specified feature and version.
`Node` `getFirstChild()` The first child of this node.
`int` `getHandleOfNode()` Non-DOM method, part of the temporary kluge %REVIEW% This would be a pruning problem, but since it will always be added to the root element and we prune on elements, we shouldn't have to worry.
`Node` `getLastChild()` The last child of this node.
`java.lang.String` `getLocalName()` Returns the local part of the qualified name of this node.
`java.lang.String` `getName()` Returns the name of this attribute.
`java.lang.String` `getNamespaceURI()` The namespace URI of this node, or `null` if it is unspecified (see ).
`Node` `getNextSibling()` The node immediately following this node.
`java.lang.String` `getNodeName()` The name of this node, depending on its type; see the table above.
`short` `getNodeType()` A code representing the type of the underlying object, as defined above.
`java.lang.String` `getNodeValue()` The value of this node, depending on its type; see the table above.
`Document` `getOwnerDocument()` The `Document` object associated with this node.
`Element` `getOwnerElement()` The `Element` node this attribute is attached to or `null` if this attribute is not in use.
`Node` `getParentNode()` The parent of this node.
`java.lang.String` `getPrefix()` The namespace prefix of this node, or `null` if it is unspecified.
`Node` `getPreviousSibling()` The node immediately preceding this node.
`TypeInfo` `getSchemaTypeInfo()` The type information associated with this attribute.
`boolean` `getSpecified()` `True` if this attribute was explicitly given a value in the instance document, `false` otherwise.
`java.lang.String` `getTextContent()` This attribute returns the text content of this node and its descendants.
`java.lang.String` `getTypeName()` The name of a type declared for the associated element or attribute, or `null` if unknown.
`java.lang.String` `getTypeNamespace()` The namespace of the type declared for the associated element or attribute or `null` if the element does not have declaration or if no namespace information is available.
`java.lang.Object` `getUserData(java.lang.String key)` Retrieves the object associated to a key on a this node.
`java.lang.String` `getValue()` On retrieval, the value of the attribute is returned as a string.
`boolean` `hasAttributes()` Returns whether this node (if it is an element) has any attributes.
`boolean` `hasChildNodes()` Returns whether this node has any children.
`Node` `insertBefore(Node a, Node b)` Inserts the node `newChild` before the existing child node `refChild`.
`boolean` `isDefaultNamespace(java.lang.String namespaceURI)` DOM Level 3: Experimental This method checks if the specified `namespaceURI` is the default namespace or not.
`boolean` `isDerivedFrom(java.lang.String ns, java.lang.String localName, int derivationMethod)` This method returns if there is a derivation between the reference type definition, i.e. the `TypeInfo` on which the method is being called, and the other type definition, i.e. the one passed as parameters.
`boolean` `isEqualNode(Node arg)` Tests whether two nodes are equal.
`boolean` `isId()` Returns whether this attribute is known to be of type ID (i.e. to contain an identifier for its owner element) or not.
`boolean` `isSameNode(Node other)` Returns whether this node is the same node as the given one.
`boolean` `isSupported(java.lang.String feature, java.lang.String version)` Tests whether the DOM implementation implements a specific feature and that feature is supported by this node, as specified in .
`java.lang.String` `lookupNamespaceURI(java.lang.String specifiedPrefix)` DOM Level 3 - Experimental: Look up the namespace URI associated to the given prefix, starting from this node.
`java.lang.String` `lookupPrefix(java.lang.String namespaceURI)` DOM Level 3 - Experimental: Look up the prefix associated to the given namespace URI, starting from this node.
`void` `normalize()` Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes.
`Node` `removeChild(Node a)` Removes the child node indicated by `oldChild` from the list of children, and returns it.
`Node` `replaceChild(Node a, Node b)` Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
`void` `setNodeValue(java.lang.String value)` The value of this node, depending on its type; see the table above.
`void` `setPrefix(java.lang.String value)` The namespace prefix of this node, or `null` if it is unspecified.
`void` `setTextContent(java.lang.String textContent)` This attribute returns the text content of this node and its descendants.
`java.lang.Object` `setUserData(java.lang.String key, java.lang.Object data, UserDataHandler handler)` Associate an object to a key on this node.
`void` `setValue(java.lang.String value)` On retrieval, the value of the attribute is returned as a string.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### getNodeName

    public java.lang.String getNodeName()

Description copied from interface: `Node`
The name of this node, depending on its type; see the table above.

Specified by:
  `getNodeName` in interface `Node`

#### getName

    public java.lang.String getName()

Description copied from interface: `Attr`
Returns the name of this attribute. If `Node.localName` is different from `null`, this attribute is a qualified name.

Specified by:
  `getName` in interface `Attr`

#### getNamespaceURI

    public java.lang.String getNamespaceURI()

Description copied from interface: `Node`
The namespace URI of this node, or `null` if it is unspecified (see ).
This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time.
For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `Document.createElement()`, this is always `null`.

Note: Per the Namespaces in XML Specification [XML Namespaces] an attribute does not inherit its namespace from the element it is attached to. If an attribute is not explicitly given a namespace, it simply has no namespace.

Specified by:
  `getNamespaceURI` in interface `Node`

#### getPrefix

    public java.lang.String getPrefix()

Description copied from interface: `Node`
The namespace prefix of this node, or `null` if it is unspecified. When it is defined to be `null`, setting it has no effect, including if the node is read-only.
Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable.
Setting the prefix to `null` makes it unspecified, setting it to an empty string is implementation dependent.
Note also that changing the prefix of an attribute that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.
For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.

Specified by:
  `getPrefix` in interface `Node`

#### getLocalName

    public java.lang.String getLocalName()

Description copied from interface: `Node`
Returns the local part of the qualified name of this node.
For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `Document.createElement()`, this is always `null`.

Specified by:
  `getLocalName` in interface `Node`

#### getNodeValue

    public java.lang.String getNodeValue()

Description copied from interface: `Node`
The value of this node, depending on its type; see the table above. When it is defined to be `null`, setting it has no effect, including if the node is read-only.

Specified by:
  `getNodeValue` in interface `Node`

#### getValue

    public java.lang.String getValue()

Description copied from interface: `Attr`
On retrieval, the value of the attribute is returned as a string. Character and general entity references are replaced with their values. See also the method `getAttribute` on the `Element` interface.
On setting, this creates a `Text` node with the unparsed contents of the string, i.e. any characters that an XML processor would recognize as markup are instead treated as literal text. See also the method `Element.setAttribute()`.
Some specialized implementations, such as some [SVG 1.1] implementations, may do normalization automatically, even after mutation; in such case, the value on retrieval may differ from the value on setting.

Specified by:
  `getValue` in interface `Attr`

#### getOwnerElement

    public Element getOwnerElement()

Description copied from interface: `Attr`
The `Element` node this attribute is attached to or `null` if this attribute is not in use.

Specified by:
  `getOwnerElement` in interface `Attr`

#### isSupported

    public boolean isSupported(java.lang.String feature,
                      java.lang.String version)

Description copied from interface: `Node`
Tests whether the DOM implementation implements a specific feature and that feature is supported by this node, as specified in .

Specified by:
  `isSupported` in interface `Node`
Parameters:
  `feature` - The name of the feature to test.
  `version` - This is the version number of the feature to test.
Returns:
  Returns `true` if the specified feature is supported on this node, `false` otherwise.

#### hasChildNodes

    public boolean hasChildNodes()

Description copied from interface: `Node`
Returns whether this node has any children.

Specified by:
  `hasChildNodes` in interface `Node`
Returns:
  Returns `true` if this node has any children, `false` otherwise.

#### hasAttributes

    public boolean hasAttributes()

Description copied from interface: `Node`
Returns whether this node (if it is an element) has any attributes.

Specified by:
  `hasAttributes` in interface `Node`
Returns:
  Returns `true` if this node has any attributes, `false` otherwise.

#### getParentNode

    public Node getParentNode()

Description copied from interface: `Node`
The parent of this node. All nodes, except `Attr`, `Document`, `DocumentFragment`, `Entity`, and `Notation` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, this is `null`.

Specified by:
  `getParentNode` in interface `Node`

#### getFirstChild

    public Node getFirstChild()

Description copied from interface: `Node`
The first child of this node. If there is no such node, this returns `null`.

Specified by:
  `getFirstChild` in interface `Node`

#### getLastChild

    public Node getLastChild()

Description copied from interface: `Node`
The last child of this node. If there is no such node, this returns `null`.

Specified by:
  `getLastChild` in interface `Node`

#### getPreviousSibling

    public Node getPreviousSibling()

Description copied from interface: `Node`
The node immediately preceding this node. If there is no such node, this returns `null`.

Specified by:
  `getPreviousSibling` in interface `Node`

#### getNextSibling

    public Node getNextSibling()

Description copied from interface: `Node`
The node immediately following this node. If there is no such node, this returns `null`.

Specified by:
  `getNextSibling` in interface `Node`

#### getSpecified

    public boolean getSpecified()

Description copied from interface: `Attr`
`True` if this attribute was explicitly given a value in the instance document, `false` otherwise. If the application changed the value of this attribute node (even if it ends up having the same value as the default value) then it is set to `true`. The implementation may handle attributes with default values from other schemas similarly but applications should use `Document.normalizeDocument()` to guarantee this information is up-to-date.

Specified by:
  `getSpecified` in interface `Attr`

#### normalize

    public void normalize()

Description copied from interface: `Node`
Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes. This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer [XPointer] lookups) that depend on a particular document tree structure are to be used. If the parameter "normalize-characters" of the `DOMConfiguration` object attached to the `Node.ownerDocument` is `true`, this method will also fully normalize the characters of the `Text` nodes.

Note: In cases where the document contains `CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `Text` nodes and `CDATASection` nodes.

Specified by:
  `normalize` in interface `Node`

#### getChildNodes

    public NodeList getChildNodes()

Description copied from interface: `Node`
A `NodeList` that contains all children of this node. If there are no children, this is a `NodeList` containing no nodes.

Specified by:
  `getChildNodes` in interface `Node`

#### getAttributes

    public NamedNodeMap getAttributes()

Description copied from interface: `Node`
A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.

Specified by:
  `getAttributes` in interface `Node`

#### getNodeType

    public short getNodeType()

Description copied from interface: `Node`
A code representing the type of the underlying object, as defined above.

Specified by:
  `getNodeType` in interface `Node`

#### setNodeValue

    public void setNodeValue(java.lang.String value)

Description copied from interface: `Node`
The value of this node, depending on its type; see the table above. When it is defined to be `null`, setting it has no effect, including if the node is read-only.

Specified by:
  `setNodeValue` in interface `Node`

#### setValue

    public void setValue(java.lang.String value)

Description copied from interface: `Attr`
On retrieval, the value of the attribute is returned as a string. Character and general entity references are replaced with their values. See also the method `getAttribute` on the `Element` interface.
On setting, this creates a `Text` node with the unparsed contents of the string, i.e. any characters that an XML processor would recognize as markup are instead treated as literal text. See also the method `Element.setAttribute()`.
Some specialized implementations, such as some [SVG 1.1] implementations, may do normalization automatically, even after mutation; in such case, the value on retrieval may differ from the value on setting.

Specified by:
  `setValue` in interface `Attr`

#### setPrefix

    public void setPrefix(java.lang.String value)

Description copied from interface: `Node`
The namespace prefix of this node, or `null` if it is unspecified. When it is defined to be `null`, setting it has no effect, including if the node is read-only.
Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable.
Setting the prefix to `null` makes it unspecified, setting it to an empty string is implementation dependent.
Note also that changing the prefix of an attribute that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.
For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.

Specified by:
  `setPrefix` in interface `Node`

#### insertBefore

    public Node insertBefore(Node a,
                    Node b)

Description copied from interface: `Node`
Inserts the node `newChild` before the existing child node `refChild`. If `refChild` is `null`, insert `newChild` at the end of the list of children.
If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed.

Note: Inserting a node before itself is implementation dependent.

Specified by:
  `insertBefore` in interface `Node`
Parameters:
  `a` - The node to insert.
  `b` - The reference node, i.e., the node before which the new node must be inserted.
Returns:
  The node being inserted.

#### replaceChild

    public Node replaceChild(Node a,
                    Node b)

Description copied from interface: `Node`
Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
If `newChild` is a `DocumentFragment` object, `oldChild` is replaced by all of the `DocumentFragment` children, which are inserted in the same order. If the `newChild` is already in the tree, it is first removed.

Note: Replacing a node with itself is implementation dependent.

Specified by:
  `replaceChild` in interface `Node`
Parameters:
  `a` - The new node to put in the child list.
  `b` - The node being replaced in the list.
Returns:
  The node replaced.

#### appendChild

    public Node appendChild(Node a)

Description copied from interface: `Node`
Adds the node `newChild` to the end of the list of children of this node. If the `newChild` is already in the tree, it is first removed.

Specified by:
  `appendChild` in interface `Node`
Parameters:
  `a` - The node to add.If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node
Returns:
  The node added.

#### removeChild

    public Node removeChild(Node a)

Description copied from interface: `Node`
Removes the child node indicated by `oldChild` from the list of children, and returns it.

Specified by:
  `removeChild` in interface `Node`
Parameters:
  `a` - The node being removed.
Returns:
  The node removed.

#### getOwnerDocument

    public Document getOwnerDocument()

Description copied from interface: `Node`
The `Document` object associated with this node. This is also the `Document` object used to create new nodes. When this node is a `Document` or a `DocumentType` which is not used with any `Document` yet, this is `null`.

Specified by:
  `getOwnerDocument` in interface `Node`

#### cloneNode

    public Node cloneNode(boolean deep)

Description copied from interface: `Node`
Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes. The duplicate node has no parent ( `parentNode` is `null`) and no user data. User data associated to the imported node is not carried over. However, if any `UserDataHandlers` has been specified along with the associated data these handlers will be called with the appropriate parameters before this method returns.
Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any children it contains unless it is a deep clone. This includes text contained in an the `Element` since the text is contained in a child `Text` node. Cloning an `Attr` directly, as opposed to be cloned as part of an `Element` cloning operation, returns a specified attribute (`specified` is `true`). Cloning an `Attr` always clones its children, since they represent its value, no matter whether this is a deep clone or not. Cloning an `EntityReference` automatically constructs its subtree if a corresponding `Entity` is available, no matter whether this is a deep clone or not. Cloning any other type of node simply returns a copy of this node.
Note that cloning an immutable subtree results in a mutable copy, but the children of an `EntityReference` clone are readonly . In addition, clones of unspecified `Attr` nodes are specified. And, cloning `Document`, `DocumentType`, `Entity`, and `Notation` nodes is implementation dependent.

Specified by:
  `cloneNode` in interface `Node`
Parameters:
  `deep` - If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).
Returns:
  The duplicate node.

#### getHandleOfNode

    public int getHandleOfNode()

Non-DOM method, part of the temporary kluge %REVIEW% This would be a pruning problem, but since it will always be added to the root element and we prune on elements, we shouldn't have to worry.

#### getTypeName

    public java.lang.String getTypeName()

Description copied from interface: `TypeInfo`
The name of a type declared for the associated element or attribute, or `null` if unknown.

Specified by:
  `getTypeName` in interface `TypeInfo`
See Also:
  `TypeInfo.getTypeName()`

#### getTypeNamespace

    public java.lang.String getTypeNamespace()

Description copied from interface: `TypeInfo`
The namespace of the type declared for the associated element or attribute or `null` if the element does not have declaration or if no namespace information is available.

Specified by:
  `getTypeNamespace` in interface `TypeInfo`
See Also:
  `TypeInfo.getTypeNamespace()`

#### isDerivedFrom

    public boolean isDerivedFrom(java.lang.String ns,
                        java.lang.String localName,
                        int derivationMethod)

Description copied from interface: `TypeInfo`
This method returns if there is a derivation between the reference type definition, i.e. the `TypeInfo` on which the method is being called, and the other type definition, i.e. the one passed as parameters.

Specified by:
  `isDerivedFrom` in interface `TypeInfo`
Parameters:
  `ns` - the namespace of the other type definition.
  `localName` - the name of the other type definition.
  `derivationMethod` - the type of derivation and conditions applied between two types, as described in the list of constants provided in this interface.
Returns:
  If the document's schema is a DTD or no schema is associated with the document, this method will always return `false` . If the document's schema is an XML Schema, the method will `true` if the reference type definition is derived from the other type definition according to the derivation parameter. If the value of the parameter is `0` (no bit is set to `1` for the `derivationMethod` parameter), the method will return `true` if the other type definition can be reached by recursing any combination of {base type definition}, {item type definition}, or {member type definitions} from the reference type definition.
See Also:
  `or.gw3c.dom.TypeInfo#isDerivedFrom(String,String,int)`

#### getSchemaTypeInfo

    public TypeInfo getSchemaTypeInfo()

Description copied from interface: `Attr`
The type information associated with this attribute. While the type information contained in this attribute is guarantee to be correct after loading the document or invoking `Document.normalizeDocument()`, `schemaTypeInfo` may not be reliable if the node was moved.

Specified by:
  `getSchemaTypeInfo` in interface `Attr`

#### isId

    public boolean isId()

Description copied from interface: `Attr`
Returns whether this attribute is known to be of type ID (i.e. to contain an identifier for its owner element) or not. When it is and its value is unique, the `ownerElement` of this attribute can be retrieved using the method `Document.getElementById` . The implementation could use several ways to determine if an attribute node is known to contain an identifier:

- If validation occurred using an XML Schema [XML Schema Part 1] while loading the document or while invoking `Document.normalizeDocument()`, the post-schema-validation infoset contributions (PSVI contributions) values are used to determine if this attribute is a schema-determined ID attribute using the schema-determined ID definition in [XPointer] .
- If validation occurred using a DTD while loading the document or while invoking `Document.normalizeDocument()`, the infoset [type definition] value is used to determine if this attribute is a DTD-determined ID attribute using the DTD-determined ID definition in [XPointer] .
- from the use of the methods `Element.setIdAttribute()`, `Element.setIdAttributeNS()`, or `Element.setIdAttributeNode()`, i.e. it is an user-determined ID attribute;

  Note: XPointer framework (see section 3.2 in [XPointer] ) consider the DOM user-determined ID attribute as being part of the XPointer externally-determined ID definition.

- using mechanisms that are outside the scope of this specification, it is then an externally-determined ID attribute. This includes using schema languages different from XML schema and DTD.

If validation occurred while invoking `Document.normalizeDocument()`, all user-determined ID attributes are reset and all attribute nodes ID information are then reevaluated in accordance to the schema used. As a consequence, if the `Attr.schemaTypeInfo` attribute contains an ID type, `isId` will always return true.

Specified by:
  `isId` in interface `Attr`

#### setUserData

    public java.lang.Object setUserData(java.lang.String key,
                               java.lang.Object data,
                               UserDataHandler handler)

Associate an object to a key on this node. The object can later be retrieved from this node by calling `getUserData` with the same key.

Specified by:
  `setUserData` in interface `Node`
Parameters:
  `key` - The key to associate the object to.
  `data` - The object to associate to the given key, or `null` to remove any existing association to that key.
  `handler` - The handler to associate to that key, or `null`.
Returns:
  Returns the `DOMObject` previously associated to the given key on this node, or `null` if there was none.
Since:
  DOM Level 3

#### getUserData

    public java.lang.Object getUserData(java.lang.String key)

Retrieves the object associated to a key on a this node. The object must first have been set to this node by calling `setUserData` with the same key.

Specified by:
  `getUserData` in interface `Node`
Parameters:
  `key` - The key the object is associated to.
Returns:
  Returns the `DOMObject` associated to the given key on this node, or `null` if there was none.
Since:
  DOM Level 3

#### getFeature

    public java.lang.Object getFeature(java.lang.String feature,
                              java.lang.String version)

This method returns a specialized object which implements the specialized APIs of the specified feature and version. The specialized object may also be obtained by using binding-specific casting methods but is not necessarily expected to, as discussed in Mixed DOM implementations.

Specified by:
  `getFeature` in interface `Node`
Parameters:
  `feature` - The name of the feature requested (case-insensitive).
  `version` - This is the version number of the feature to test. If the version is `null` or the empty string, supporting any version of the feature will cause the method to return an object that supports at least one version of the feature.
Returns:
  Returns an object which implements the specialized APIs of the specified feature and version, if any, or `null` if there is no object which implements interfaces associated with that feature. If the `DOMObject` returned by this method implements the `Node` interface, it must delegate to the primary core `Node` and not return results inconsistent with the primary core `Node` such as attributes, childNodes, etc.
Since:
  DOM Level 3

#### isEqualNode

    public boolean isEqualNode(Node arg)

Tests whether two nodes are equal.
This method tests for equality of nodes, not sameness (i.e., whether the two nodes are references to the same object) which can be tested with `Node.isSameNode`. All nodes that are the same will also be equal, though the reverse may not be true.
Two nodes are equal if and only if the following conditions are satisfied: The two nodes are of the same type.The following string attributes are equal: `nodeName`, `localName`, `namespaceURI`, `prefix`, `nodeValue` , `baseURI`. This is: they are both `null`, or they have the same length and are character for character identical. The `attributes` `NamedNodeMaps` are equal. This is: they are both `null`, or they have the same length and for each node that exists in one map there is a node that exists in the other map and is equal, although not necessarily at the same index.The `childNodes` `NodeLists` are equal. This is: they are both `null`, or they have the same length and contain equal nodes at the same index. This is true for `Attr` nodes as for any other type of node. Note that normalization can affect equality; to avoid this, nodes should be normalized before being compared.
For two `DocumentType` nodes to be equal, the following conditions must also be satisfied: The following string attributes are equal: `publicId`, `systemId`, `internalSubset`.The `entities` `NamedNodeMaps` are equal.The `notations` `NamedNodeMaps` are equal.
On the other hand, the following do not affect equality: the `ownerDocument` attribute, the `specified` attribute for `Attr` nodes, the `isWhitespaceInElementContent` attribute for `Text` nodes, as well as any user data or event listeners registered on the nodes.

Specified by:
  `isEqualNode` in interface `Node`
Parameters:
  `arg` - The node to compare equality with.
  `deep` - If `true`, recursively compare the subtrees; if `false`, compare only the nodes themselves (and its attributes, if it is an `Element`).
Returns:
  If the nodes, and possibly subtrees are equal, `true` otherwise `false`.
Since:
  DOM Level 3

#### lookupNamespaceURI

    public java.lang.String lookupNamespaceURI(java.lang.String specifiedPrefix)

DOM Level 3 - Experimental: Look up the namespace URI associated to the given prefix, starting from this node. Use lookupNamespaceURI(null) to lookup the default namespace

Specified by:
  `lookupNamespaceURI` in interface `Node`
Parameters:
  `namespaceURI` -
Returns:
  th URI for the namespace
Since:
  DOM Level 3

#### isDefaultNamespace

    public boolean isDefaultNamespace(java.lang.String namespaceURI)

DOM Level 3: Experimental This method checks if the specified `namespaceURI` is the default namespace or not.

Specified by:
  `isDefaultNamespace` in interface `Node`
Parameters:
  `namespaceURI` - The namespace URI to look for.
Returns:
  `true` if the specified `namespaceURI` is the default namespace, `false` otherwise.
Since:
  DOM Level 3

#### lookupPrefix

    public java.lang.String lookupPrefix(java.lang.String namespaceURI)

DOM Level 3 - Experimental: Look up the prefix associated to the given namespace URI, starting from this node.

Specified by:
  `lookupPrefix` in interface `Node`
Parameters:
  `namespaceURI` -
Returns:
  the prefix for the namespace

#### isSameNode

    public boolean isSameNode(Node other)

Returns whether this node is the same node as the given one.
This method provides a way to determine whether two `Node` references returned by the implementation reference the same object. When two `Node` references are references to the same object, even if through a proxy, the references may be used completely interchangably, such that all attributes have the same values and calling the same DOM method on either reference always has exactly the same effect.

Specified by:
  `isSameNode` in interface `Node`
Parameters:
  `other` - The node to test against.
Returns:
  Returns `true` if the nodes are the same, `false` otherwise.
Since:
  DOM Level 3

#### setTextContent

    public void setTextContent(java.lang.String textContent)
                        throws DOMException

This attribute returns the text content of this node and its descendants. When it is defined to be null, setting it has no effect. When set, any possible children this node may have are removed and replaced by a single `Text` node containing the string this attribute is set to. On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed, the returned string does not contain the element content whitespaces . Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
The string returned is made of the text content of this node depending on its type, as defined below:

Node type | Content
--- | ---
ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes
ATTRIBUTE_NODE, TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

Specified by:
  `setTextContent` in interface `Node`
Throws:
  `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
  `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.
Since:
  DOM Level 3

#### getTextContent

    public java.lang.String getTextContent()
                                    throws DOMException

This attribute returns the text content of this node and its descendants. When it is defined to be null, setting it has no effect. When set, any possible children this node may have are removed and replaced by a single `Text` node containing the string this attribute is set to. On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed, the returned string does not contain the element content whitespaces . Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
The string returned is made of the text content of this node depending on its type, as defined below:

Node type | Content
--- | ---
ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes
ATTRIBUTE_NODE, TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

Specified by:
  `getTextContent` in interface `Node`
Throws:
  `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
  `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.
Since:
  DOM Level 3

#### compareDocumentPosition

    public short compareDocumentPosition(Node other)
                                  throws DOMException

Compares a node with this node with regard to their position in the document.

Specified by:
  `compareDocumentPosition` in interface `Node`
Parameters:
  `other` - The node to compare against this node.
Returns:
  Returns how the given node is positioned relatively to this node.
Throws:
  `DOMException` - NOT_SUPPORTED_ERR: when the compared nodes are from different DOM implementations that do not coordinate to return consistent implementation-specific results.
Since:
  DOM Level 3

#### getBaseURI

    public java.lang.String getBaseURI()

The absolute base URI of this node or `null` if undefined. This value is computed according to . However, when the `Document` supports the feature "HTML" , the base URI is computed using first the value of the href attribute of the HTML BASE element if any, and the value of the `documentURI` attribute from the `Document` interface otherwise.
When the node is an `Element`, a `Document` or a a `ProcessingInstruction`, this attribute represents the properties [base URI] defined in . When the node is a `Notation`, an `Entity`, or an `EntityReference`, this attribute represents the properties [declaration base URI] in the . How will this be affected by resolution of relative namespace URIs issue?It's not.Should this only be on Document, Element, ProcessingInstruction, Entity, and Notation nodes, according to the infoset? If not, what is it equal to on other nodes? Null? An empty string? I think it should be the parent's.No.Should this be read-only and computed or and actual read-write attribute?Read-only and computed (F2F 19 Jun 2000 and teleconference 30 May 2001).If the base HTML element is not yet attached to a document, does the insert change the Document.baseURI? Yes. (F2F 26 Sep 2001)

Specified by:
  `getBaseURI` in interface `Node`
Since:
  DOM Level 3